#!/usr/local/bin/perl

my @suff = ("TXT", "PL", "SH", "HTML", "JAVA", "JSP", "HTM");

my $rootdir = $ARGV[0];
my $from = $ARGV[1];
my $to = $ARGV[2];

# $initdir = getcwd ();

@list =();
listdirectory($rootdir);
for $loopindex (0..$#list) {
  my $filename = $list[$loopindex];
  my $flag = 0;
  for $suffindex (0..$#suff) {
  # \w does not match ".". So we will ONLY match the last suffix
    if ( $filename =~ m/\.(\w+)$/ ) {
      my $realsuff = $1;
      $realsuff = uc $realsuff;
      if ( $realsuff eq $suff[$suffindex] ) {
        $flag = 1;
      }
    }
  }
  if ( $flag == 1 ) {
    replaceStuff($filename, $from, $to);
  }
}          
# chdir $initdir;
exit 0;

sub listdirectory {
  local($dir);
  local(@lines);
  local($fileitem);
  local($lvl_counter);
  local($list_length);

  $dir = shift;
  if(opendir (DIR, $dir)) {
    @lines = readdir (DIR);
    closedir (DIR);
    $lvl_counter = 2;
    $list_length = ( scalar @lines );                                          
    while ($lvl_counter < $list_length) {
      $fileitem = $dir."/".$lines[$lvl_counter];
      if( -d $fileitem) {
        listdirectory($fileitem);
      } else {
        push @list, $fileitem;
      }
      $lvl_counter++;
    }
  }
}                               

sub replaceStuff {
  my $filename = shift;
  my $from = shift;
  my $to = shift;
  $tmp_filename = "$filename.tmp";
  system "/bin/sed \'s,$from,$to,g\' < $filename > $tmp_filename";
  system "mv $tmp_filename $filename";
}

