#!/usr/local/bin/perl

push(@INC, ".");
use CGI;
require("DBAccess.pl");

my $query = new CGI;
my $qdata_foldername = $query->param('foldername');
my $qdata_indexname = $query->param('indexname');
my $qdata_imgname = $query->param('imgname');
my $qdata_name = $query->param('name');
my $qdata_comment = $query->param('comment');

my $db = DBAccess->new("config.xml", $qdata_foldername, $qdata_indexname);
my $codebase = $db -> getCodebase();
my $imagebase = $db -> getImageBase();
my $isAllowComment = $db -> getAllowComment();
my $isAllowUserUpload = $db -> getAllowUserUpload();

if ( $isAllowComment eq "no" ) {
  print $query->header();
  print "<html><head><title>Error</title>\n";
  print "<body bgcolor=white><p>You are not allowed to comment \n";
  print "<p><a href=\"javascript:history.go(-1)\">Go back</a> \n";
  print "</body></html> \n";
  exit;
}

#The message will be changed to empty string if it only contains
#blank chars. This empty string will be rejected by chechstring() 
#later
$qdata_comment =~ s/[\n\r]/ /;
$qdata_comment =~ s/^\s*$//;

#The poster name will be changed to anomynous if 
#it only contains blank chars
$qdata_name =~ s/[\n\r]/ /;
$qdata_name =~ s/^\s*$/Anonymous/;

my %comm = ();
$comm{ImageName} = $qdata_imgname;
$comm{User} = $qdata_name;
$comm{CommentText} = $qdata_comment;

if ( (DBAccess->isAllowed($qdata_name) eq "no") || (DBAccess->isAllowed($qdata_comment) eq "no") ) {
  print $query->header();
  print "<html><head><title>Error</title>\n";
  print "<body bgcolor=white><p>You used some illegal HTML tags \n";
  print "<p><a href=\"javascript:history.go(-1)\">Go back</a> \n";
  print "</body></html> \n";
  exit;
}

my $stringStatus = checkString("$qdata_comment");

if ( $stringStatus eq "success" && $filename eq $imgname ) {
  $db -> addImageComment ( \%comm );
#  $db -> addImageComment ( $qdata_imgname, $qdata_name, $qdata_comment );
}

if ( $stringStatus eq "success" ) {
  print $query->redirect("$codebase/PhotoView.pl?imgname=$qdata_imgname&foldername=$qdata_foldername&indexname=$qdata_indexname");
} else {
  print $query->header();
  print "<html><head><title>Image viewer</title>\n";
  print "</head>\n";
  print "<body bgcolor=\"#FFFFFF\">\n";
  print "Your comment contains illegal chars! $stringStatus $status";
  print "</body></html> \n";
}

exit 0;

sub checkString {
  
  my $value = shift(@_);
  if ( ($value =~ m/\&/i) || ($value =~ m/#/i) || ($value eq "") ) {
    return "fail";
  } else {
    return "success";
  }

}

