#!/usr/local/bin/perl

push(@INC, "..");
use CGI;
require("DBAccess.pl");

my $query = new CGI;
my $qdata_foldername = $query->param('foldername');
my $qdata_indexname = $query->param('indexname');

my $db = DBAccess->new("../config.xml", $qdata_foldername, $qdata_indexname);

my %globaldata = $db -> getGlobalDef ();
my $imagebase = $db -> getImageBase();
my $codebase = $db -> getCodebase();
my $isAllowComment = $db -> getAllowComment();
my $isAllowUserUpload = $db -> getAllowUserUpload();
my @imagenames = $db -> getImageNameList ();
# my @imagenames = $db -> getViewableImageNameList ();

print $query->header();
print "<html><head><title>Image viewer</title>\n";
print "</head>\n";
print "<body bgcolor=\"#FFFFFF\">\n";

print "<p><a href=\"$codebase/ShowIndex.pl?foldername=$qdata_foldername&indexname=$qdata_indexname\">Normal Viewer</a> -- ";
print "<a href=\"$codebase/admin/UploadForm.pl?foldername=$qdata_foldername&indexname=$qdata_indexname\">Upload more pictures</a>";

print "<form action=\"UpdateIndex.pl\" method=\"POST\">\n";

print "<p>Allow User comments? \n";
if ( $isAllowComment eq "yes" ) {
  print "<input name=isAllowComment type=radio value=yes checked> Yes"; 
  print "<input name=isAllowComment type=radio value=no> No "; 
} else {
  print "<input name=isAllowComment type=radio value=yes> Yes"; 
  print "<input name=isAllowComment type=radio value=no checked> No "; 
}
print "<p>Allow User Upload? \n";
if ( $isAllowUserUpload eq "yes" ) {
  print "<input name=isAllowUserUpload type=radio value=yes checked> Yes"; 
  print "<input name=isAllowUserUpload type=radio value=no> No "; 
} else {
  print "<input name=isAllowUserUpload type=radio value=yes> Yes"; 
  print "<input name=isAllowUserUpload type=radio value=no checked> No "; 
}

print "<center>\n";
print "<p><h1>Title</h1>\n";
print "<p><input type=text name=\"Title\" value=\"$globaldata{Title}\">\n";
print "<p>Introduction\n";
print "<p><textarea cols=60 rows=10 name=\"Introduction\">$globaldata{Introduction}</textarea>\n";
print "<input type=hidden name=\"foldername\" value=\"$qdata_foldername\">\n";
print "<input type=hidden name=\"indexname\" value=\"$qdata_indexname\">\n";
print "<p><TABLE border><tr>\n";

my $counter = 0;
print "<table border> \n";
print "<tr> \n";
for (my $i=0; $i<=$#imagenames; $i=$i+1) {
  my %imagedata = $db -> getImage($imagenames[$i]);

  if ($imagedata{Hidden} eq "yes") { 
    print "<td><input type=checkbox name=changestatus value=$imagenames[$i]>";
    print "<font color=red>Show</font>";
  } else {
    print "<td><input type=checkbox name=changestatus value=$imagenames[$i]>";
    print "Hide";
  }

  print "<p><a href=\"$codebase/admin/Photo.pl?foldername=$qdata_foldername&indexname=$qdata_indexname&imgname=$imagenames[$i]\"><img src=\"$imagebase/$imagedata{ThumbnailName}\"/></a>";
  print "<p><font face=\"Arial,Helvetica\" size=2>$imagedata{ImageTitle}</font></td> \n";
  $counter = $counter + 1;
  if ( $counter == 4 ) {
    $counter = 0;
    print "</tr><tr> \n";
  }
}
print "</tr> \n";
print "</table>\n";


print "<p>Closing\n";
print "<p><textarea cols=60 rows=10 name=Closing>$globaldata{Closing}</textarea>\n";
print "<p><input type=submit value=\"update\"><input type=reset value=\"clear\">\n";
print "</form>\n";
print "<a href=\"../ShowIndex.pl?foldername=$qdata_foldername&indexname=$qdata_indexname\"> GoTo Viewer </a> \n";
print "</center></body></html>\n";

exit 0;
