#!/usr/local/bin/perl

push(@INC, "..");
use CGI;
require("DBAccess.pl");

my $query = new CGI;
my $qdata_foldername = $query->param('foldername');
my $qdata_createfolder = $query->param('createfolder');
my $qdata_isAllowComment = $query->param('isAllowComment');
my $qdata_isAllowUserUpload = $query->param('isAllowUserUpload');
my $qdata_indexname = $query->param('indexname');
my $qdata_resizeop = $query->param('resizeop');
my $qdata_display = $query->param('display');
my $qdata_displayresizeop = $query->param('displayresizeop');

my $config = Config->new("../config.xml");
my $AbsoluteFolderName = "$config->{docrootPath}/$config->{partytimeDOCDir}/$qdata_foldername";

if ( $qdata_createfolder eq "yes" && !(-e $AbsoluteFolderName) ) {
  system("mkdir -p -m 0755 $AbsoluteFolderName");
}

# if qdata_isAllowComment or qdata_isAllowUserUpload is unchecked -- empty
# it will affect the parameter sequence for the command below.
if ( $qdata_isAllowComment ne "yes" ) { $qdata_isAllowComment = "no"; }
if ( $qdata_isAllowUserUpload ne "yes" ) { $qdata_isAllowUserUpload = "no"; }

# make sure that display options have values
if ( $qdata_display eq "" ) { $qdata_display = "no"; }
if ( $qdata_displayresizeop eq "" ) { $qdata_display = "640x480"; }

system("perl MakeAlbum.pl $qdata_foldername $qdata_indexname $qdata_resizeop $qdata_display $qdata_displayresizeop $qdata_isAllowComment $qdata_isAllowUserUpload &");

while ( !(-e "$AbsoluteFolderName/lock.file") && 
        !(-e "$AbsoluteFolderName/$qdata_indexname") ) {  }

my $codebase = "$config->{cgiURL}/$config->{partytimeCGIDir}";
print $query->redirect("$codebase/admin/CheckStatus.pl?foldername=$qdata_foldername&indexname=$qdata_indexname");

exit 0;
