#!/usr/local/bin/perl

push(@INC, "..");
use CGI;
require("DBAccess.pl");

my $query = new CGI;
my $qdata_foldername = $query->param('foldername');
my $qdata_indexname = $query->param('indexname');
my $qdata_resizeop = $query->param('resizeop');
my $qdata_display = $query->param('display');
my $qdata_displayresizeop = $query->param('displayresizeop');

my $db = DBAccess->new("../config.xml", $qdata_foldername, $qdata_indexname);

my $filepath=$query->param('uploadfile');
if ($filepath =~ /([^\/\\]+)$/) {
  $filename="$1";
} else {
  $filename="$filepath";
}
# if there's any space in the filename, get rid of them
$filename =~ s/\s+//g;

$write_file = ($db->getAbsoluteFolderName ()) . "/" . "$filename";

open(WFD,">$write_file");
while ($bytes_read=read($filepath,$buff,2096)) {
  $size += $bytes_read;
  binmode WFD;
  print WFD $buff;
}
close(WFD);
if ((stat $write_file)[7] <= 0) {
  unlink($write_file);
}

if ( $qdata_resizeop == undef || $qdata_resizeop eq ""
                              || $qdata_resizeop=~m/\s+/ ) {
    $qdata_resizeop = "25%x25%";
}

if ( $qdata_displayresizeop == undef || $qdata_displayresizeop eq ""
                                     || $qdata_displayresizeop=~m/\s+/ ) {
    $qdata_displayresizeop = "640x480";
}

$db -> setThumbnailLock ();
$db -> resize ( $filename, $qdata_resizeop, "TN" );
if ( $qdata_display eq "yes" ) {
  $db -> resize ( $filename, $qdata_displayresizeop, "DP" );
}

my %imagedata = ();
if ( $qdata_display eq "yes" ) {
  $imagedata{FullImage} = "$filename";
  $imagedata{ImageName} = "DP-$filename";
} else {
  $imagedata{ImageName} = "$filename";
}
$imagedata{ThumbnailName} = "TN-$filename";
$imagedata{ImageTitle} = " ";
$imagedata{ImageDescription} = " ";
$imagedata{Hidden} = "no";
$db -> addImage( \%imagedata );

$db -> releaseThumbnailLock ();

my $codebase = $db -> getCodebase();
print $query->redirect("$codebase/admin/Index.pl?foldername=$qdata_foldername&indexname=$qdata_indexname");

exit 0;
