#!/usr/local/bin/perl

package Config;

use lib "/usr/local/perl/lib";
use XML::DOM;

my $config_doc;

sub new {

#Para: "Config FileName"

  my $class = shift;
  my $config_filename = shift;
  my $self = {};

  my $parser = new XML::DOM::Parser;
  $config_doc = $parser->parsefile ("$config_filename");
  my $PathNames = ($config_doc->getElementsByTagName ("PathNames"))-> item(0);

  $self->{cgiPath} = ($PathNames->getAttributeNode ("cgiPath"))->getValue;
  $self->{cgiURL} = ($PathNames->getAttributeNode ("cgiURL"))->getValue;
  $self->{docrootPath} = ($PathNames->getAttributeNode ("docrootPath"))->getValue;
  $self->{docrootURL} = ($PathNames->getAttributeNode ("docrootURL"))->getValue;
  $self->{partytimeCGIDir} = ($PathNames->getAttributeNode("partytimeCGIDir"))->getValue;
  $self->{partytimeDOCDir} = ($PathNames->getAttributeNode("partytimeDOCDir"))->getValue;
  $self->{ImageMagickBin} = ($PathNames->getAttributeNode("ImageMagickBin"))->getValue;

  $self->{codebase} = "$self->{cgiURL}/$self->{partytimeCGIDir}";

  bless $self, $class;
  return $self;
}

sub DESTROY {

  return 0;

}

return 1;
