#!/usr/local/bin/perl

push(@INC, ".");
use CGI;
require("DBAccess.pl");

my $query = new CGI;
my $qdata_foldername = $query->param('foldername');
my $qdata_indexname = $query->param('indexname');
my $qdata_imgname = $query->param('imgname');

my $db = DBAccess->new("config.xml", $qdata_foldername, $qdata_indexname);

my $imagebase = $db -> getImageBase();
my $codebase = $db -> getCodebase();
my $isAllowComment = $db -> getAllowComment();
my $isAllowUserUpload = $db -> getAllowUserUpload();
my %imageinfo = $db -> getImage( $qdata_imgname );
my @imagecomm = $db -> getImageComments( $qdata_imgname );
my @imagenames = $db -> getViewableImageNameList ();

my $prev_image = "";
my $next_image = "";
for ( $i = 0; $i <= $#imagenames; $i = $i + 1 ) {
  if ( $qdata_imgname eq $imagenames[$i] ) {
    if ( $i == 0 ) {
    } else {
      $prev_image = $imagenames[$i-1];
    }
    if ( $i == $#imagenames ) {
    } else {
      $next_image = $imagenames[$i+1];
    }
  }
}

print $query->header();
print "<html><head><title>Image viewer</title>\n";
print "</head>\n";
print "<body bgcolor=\"#FFFFFF\">\n";

print "<table width=100%><tr><td align=left>";
if ( $prev_image ne "" ) {
  print "<a href=\"$codebase/PhotoView.pl?foldername=$qdata_foldername&indexname=$qdata_indexname&imgname=$prev_image\">Prev</a> || ";
}
if ( $next_image ne "" ) {
  print "<a href=\"$codebase/PhotoView.pl?foldername=$qdata_foldername&indexname=$qdata_indexname&imgname=$next_image\">Next</a> ";
}
print "</td></tr><tr><td align=right>";
print "<a href=\"$codebase/admin/Photo.pl?foldername=$qdata_foldername&indexname=$qdata_indexname&imgname=$qdata_imgname\">Admin</a> -- ";
print "<a href=\"$codebase/ShowIndex.pl?foldername=$qdata_foldername&indexname=$qdata_indexname\">Index</a>";
print "</td></tr></table>";


print "<center> \n";
print "<p><h1>$imageinfo{ImageTitle}</h1> \n";
print "<p>$imageinfo{ImageDescription} \n";
print "</center> \n";

my $comments_no = ($#imagecomm + 1)/3;
print "<p>It has <font color=red>$comments_no</font> comments \n";

print "<center> \n";
if (" " ne $imageinfo{FullImage}) {
  print "<p><a href=\"$imagebase/$imageinfo{FullImage}\"> ";
  print "High Quality Image </a>";
}
print "<p><img src=$imagebase/$qdata_imgname></center>\n";

if ($#imagecomm > 0) {
  print "<p>Comments \n";
}
print "<table border> \n";
for (my $i = 0; $i < ($#imagecomm+1)/3; $i++) {
  print "<tr><td><b>$imagecomm[$i*3+1]</b></td> \n";
  print "<td>$imagecomm[$i*3+2]</td></tr> \n";
}
print "</table> \n";
print "<center> \n";

if ( $isAllowComment eq "yes" ) {
  print "<font face=\"Arial,Helvetica\">\n";
  print "<p><form method=\"POST\" action=AddComment.pl> \n";
  print "<input type=hidden name=\"indexname\" value=\"$qdata_indexname\">\n";
  print "<input type=hidden name=\"foldername\" value=\"$qdata_foldername\">\n";
  print "<input type=hidden name=\"imgname\" value=\"$qdata_imgname\">\n";
  print "<p>Your Name:<input type=text name=\"name\" size=10></input>\n";
  print "<p>Your Comment:<input type=text name=\"comment\" size=60></input>\n";
  print "<p><input type=submit value=\"submit\"></input>\n";
  print "<input type=reset value=\"clear\"></input>\n";
  print "</form></font>\n";
}

print "<p><a href=\"$codebase/ShowIndex.pl?foldername=$qdata_foldername&indexname=$qdata_indexname\"> Back to index </a> \n";

print "</center> \n";
print "</body></html>\n";

exit 0;
