#!/usr/local/bin/perl

push(@INC, ".");
use CGI;
require("DBAccess.pl");

my $query = new CGI;
my $qdata_foldername = $query->param('foldername');
my $qdata_indexname = $query->param('indexname');

my $db = DBAccess->new("config.xml", $qdata_foldername, $qdata_indexname);

my %globaldata = $db -> getGlobalDef ();
my $imagebase = $db -> getImageBase();
my $codebase = $db -> getCodebase();
my $isAllowComment = $db -> getAllowComment();
my $isAllowUserUpload = $db -> getAllowUserUpload();
# my @imagenames = $db -> getImageNameList ();
my @imagenames = $db -> getViewableImageNameList ();

print $query->header();
print "<html><head><title>Image viewer</title>\n";
print "</head>\n";
print "<body bgcolor=\"#FFFFFF\">\n";

print "<table width=100%><tr><td align=right>";
print "<a href=\"$codebase/admin/Index.pl?foldername=$qdata_foldername&indexname=$qdata_indexname\">Admin</a> -- ";
if ( $isAllowUserUpload eq "yes" ) {
  print "<a href=\"$codebase/UploadForm.pl?foldername=$qdata_foldername&indexname=$qdata_indexname\"> Upload New Image </a> -- ";
}
print "<a href=\"$codebase/SlideShow.pl?foldername=$qdata_foldername&indexname=$qdata_indexname\">SlideShow</a>";
print "</td></tr></table>";

print "<center>\n";
print "<p><h1><font face=\"Arial,Helvetica\">$globaldata{Title} </font></h1>\n";
print "<p><font face=\"Arial,Helvetica\">$globaldata{Introduction}</font>\n";

my $counter = 0;
print "<table border> \n"; 
print "<tr> \n"; 
for (my $i=0; $i<=$#imagenames; $i=$i+1) {
  print "<td>";
  my %imagedata = $db -> getImage($imagenames[$i]);

  my @imagecomm = $db -> getImageComments( $imagenames[$i] );
  my $comments_no = ($#imagecomm + 1)/3;
  if ( $comments_no != 0 ) {
    print "<center><font size=-1 color=green> ";
    print "$comments_no comments</font></center> <br> \n";
  }

  print "<a href=\"$codebase/PhotoView.pl?foldername=$qdata_foldername&indexname=$qdata_indexname&imgname=$imagenames[$i]\"><img src=\"$imagebase/$imagedata{ThumbnailName}\"/></a>";
  print "<p><font face=\"Arial,Helvetica\" size=2>$imagedata{ImageTitle}</font></td> \n"; 
  $counter = $counter + 1;
  if ( $counter == 4 ) {
    $counter = 0;
    print "</tr><tr> \n";
  }
}
print "</tr> \n"; 
print "</table>\n";



print "<p><font face=\"Arial,Helvetica\" size=2>$globaldata{Closing}</font>\n";
print "</center></body></html>\n";

exit 0;
