#!/usr/local/bin/perl

push(@INC, ".");
use CGI;
require("DBAccess.pl");

my $query = new CGI;
my $qdata_foldername = $query->param('foldername');
my $qdata_indexname = $query->param('indexname');
my $qdata_current = $query->param('current');
my $qdata_pause = $query->param('pause');
my $newone = $qdata_current + 1;

my $db = DBAccess->new("config.xml", $qdata_foldername, $qdata_indexname);

my $imagebase = $db -> getImageBase();
my $codebase = $db -> getCodebase();
my @imagenames = $db -> getViewableImageNameList ();
my %imageinfo = $db -> getImage( $imagenames[$qdata_current] );
my @imagecomm = $db -> getImageComments( $imagenames[$qdata_current] );

print $query->header();

if ( $qdata_current > $#imagenames ) {

  print "<html><head><meta http-equiv=\"REFRESH\" content=\"0; URL=ShowIndex.pl?foldername=$qdata_foldername&indexname=$qdata_indexname\"></head></html>";
  print "<html><body bgcolor=white></body></html> \n";

} else {

  if ( $qdata_pause eq "yes" ) {
    print "<html><head></head> \n";
    print "<body bgcolor=\"#FFFFFF\">\n";
    print "<table width=100%><tr><td align=right>";
    print "<a href=\"$codebase/ShowIndex.pl?foldername=$qdata_foldername&indexname=$qdata_indexname\">Stop</a> || ";
    print "<a href=\"$codebase/SlideShow.pl?foldername=$qdata_foldername&indexname=$qdata_indexname&current=$qdata_current\">Resume</a>";
    print "</td></tr></table>";
  } else {
    print "<html><head><meta http-equiv=\"REFRESH\" content=\"5; URL=SlideShow.pl?foldername=$qdata_foldername&indexname=$qdata_indexname&current=$newone\"></head>"; 
    print "<body bgcolor=\"#FFFFFF\">\n";
    print "<table width=100%><tr><td align=right>";
    print "<a href=\"$codebase/ShowIndex.pl?foldername=$qdata_foldername&indexname=$qdata_indexname\">Stop</a> || ";
    print "<a href=\"$codebase/SlideShow.pl?foldername=$qdata_foldername&indexname=$qdata_indexname&current=$qdata_current&pause=yes\">Pause</a> ";
    print "</td></tr></table>";
  }

  print "<center> \n";
  print "<p><h1>$imageinfo{ImageTitle}</h1> \n";
  print "<p>$imageinfo{ImageDescription} \n";
  print "</center> \n";

  my $comments_no = ($#imagecomm + 1)/3;
  print "<p>It has <font color=red>$comments_no</font> comments \n";

  print "<center> \n";
  print "<p><img src=$imagebase/$imagenames[$qdata_current]></center>\n";

  if ($#imagecomm > 0) {
    print "<p>Comments \n";
  }
  print "<table border> \n";
  for (my $i = 0; $i < ($#imagecomm+1)/3; $i++) {
    print "<tr><td><b>$imagecomm[$i*3+1]</b></td> \n";
    print "<td>$imagecomm[$i*3+2]</td></tr> \n";
  }
  print "</table> \n";


  print "<center><p><a href=\"$codebase/ShowIndex.pl?foldername=$qdata_foldername&indexname=$qdata_indexname\"> Stop Show </a> \n";

  print "</center> \n";
  print "</body></html>\n";

}

exit 0;
